
local t = TRCLOOT

t.drawFrame = CreateFrame("Frame", nil, UIParent)
t.drawFrame:SetFrameStrata("LOW")
t.drawFrame:SetWidth(70)
t.drawFrame:SetHeight(16)
t.drawFrame:SetPoint("CENTER", UIParent, "CENTER",0,0)
t.drawFrame:Show()

-- Draw all reports
t.drawReports = function()
    local t = TRCLOOT
    t.reports = t.reports or {}



    -- setup
    local f = t.drawFrame



    -- Move me area
    t.moveMe = t.moveMe or f:CreateTexture(nil, "LOW", nil, 0)
    t.moveMe:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
    t.moveMe:SetVertexColor(.1,.1,.1,0.7)

    -- Get offsets from saved variables if possible
    if t.svc and t.svc.anchorOffsetX then
        local anchorOffsetX = t.svc.anchorOffsetX or 0
        local anchorOffsetY = t.svc.anchorOffsetY or 0
        local anchorSelf = t.svc.anchorSelf or "CENTER"
        local anchorOther = t.svc.anchorOther or "CENTER"
        f:SetPoint(anchorSelf, UIParent, anchorOther, anchorOffsetX, anchorOffsetY)
    end

    t.moveMe:SetPoint("CENTER", f, "CENTER", 0, 0)
    t.moveMe:SetWidth(f:GetWidth())
    t.moveMe:SetHeight(f:GetHeight())    

    t.moveMeText = t.moveMeText or f:CreateFontString(nil, "LOW", nil, 1)
    t.moveMeText:SetFont(t.getVar("fontPath"), 11)
    t.moveMeText:SetPoint("CENTER", t.moveMe, "CENTER", 0 , 0)
    t.moveMeText:SetText("Move me")

    if t.getVar("showMoveMe") then
        t.moveMe:Show()
        t.moveMeText:Show()
        -- Move Me function
        f:SetScript("OnMouseDown", function(self, button)
            f:SetMovable(true)
            f:StartMoving()
        end)

        f:SetScript("OnMouseUp", function(self, button)
            f:StopMovingOrSizing()
            f:SetMovable(false)
            if t.svc then
                local newAnchorSelf, _,newAnchorOther, newAnchorOffsetX, newAnchorOffsetY = f:GetPoint(1)
                t.svc.anchorSelf = newAnchorSelf
                t.svc.anchorOther = newAnchorOther
                t.svc.anchorOffsetX = newAnchorOffsetX
                t.svc.anchorOffsetY = newAnchorOffsetY
            end
            
        end)
    else
        t.moveMe:Hide()
        t.moveMeText:Hide()
        f:SetScript("OnMouseDown", nil)
        f:SetScript("OnMouseUp", nil)
    end







    -- Bg frame
    t.bg = t.bg or f:CreateTexture(nil, "LOW", nil, -2)
    t.bg:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
    t.bg:SetVertexColor(.1,.1,.1,0.7)
    t.bg:SetPoint("TOPLEFT", t.moveMe, "BOTTOMLEFT", -t.ui.ITEM_SPACING-1, t.ui.ITEM_SPACING+1)
    t.bg:SetWidth(t.ui.MAIN_WINDOW_WIDTH)
    t.bg:Hide()  


    local anchorTo = t.bg
    local anchorPoint = "TOP"
    t.itemCount = 0

    -- Item UI elements are stored in here
    t.itemBars = t.itemBars or {}


    -- For each offered item (item holds all data for that item)
    for origin, originVal in pairs(t.reports) do
        for itemID, item in pairs(originVal) do
            t.itemCount = t.itemCount + 1
            -- Holds all the ui elements for one item
            t.itemBars[t.itemCount] = t.itemBars[t.itemCount] or {}
            local i = t.itemBars[t.itemCount]


            -- Item BG
            i.bg = i.bg or f:CreateTexture(nil, "LOW", nil, -1)
            i.bg:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
            i.bg:SetVertexColor(0,0,0,.9)
            i.bg:SetPoint("TOP", anchorTo, anchorPoint, 0, -t.ui.ITEM_SPACING)
            i.bg:SetWidth(t.ui.MAIN_WINDOW_WIDTH - 2*t.ui.ITEM_SPACING)
            i.bg:SetHeight(t.ui.ITEM_HEIGHT)
            i.bg:Show()  

            anchorTo = i.bg
            anchorPoint = "BOTTOM"

            -- Item icon
            local iconName = GetItemIcon(item.item)

            i.icon = i.icon or f:CreateTexture(nil, "LOW", nil, 1)
            i.icon:SetTexture(iconName)
            i.icon:SetTexCoord(.075,.925,.075,.925)
            i.icon:SetPoint("TOPLEFT", i.bg, "TOPLEFT", t.ui.ITEM_INNER_MARGIN, -t.ui.ITEM_INNER_MARGIN)
            i.icon:SetWidth(t.ui.ITEM_HEIGHT - 2*t.ui.ITEM_INNER_MARGIN)
            i.icon:SetHeight(t.ui.ITEM_HEIGHT - 2*t.ui.ITEM_INNER_MARGIN)
            i.icon:Show()  


            -- Item text
            i.nameText = i.nameText or f:CreateFontString(nil, "LOW", nil, 1)
            i.nameText:Hide()
            i.nameText:SetFont(t.getVar("fontPath"), 14, "OUTLINE")
            i.nameText:Show()
            i.nameText:SetPoint("TOPLEFT", i.icon, "TOPRIGHT", t.ui.ITEM_INNER_MARGIN , 0)
            i.nameText:SetText(item.item)
            i.nameText:SetWidth(t.ui.MAIN_WINDOW_WIDTH - 18 - t.ui.ITEM_HEIGHT - 4* t.ui.ITEM_INNER_MARGIN)
            i.nameText:SetJustifyH("LEFT")
            i.nameText:SetWordWrap(false)
            i.nameText:Show()

            -- To text

            local toNameFull = "..."
            if item.responses and item.responses[1] then
                toNameFull = item.responses[1].sender
            end

            local toName = toNameFull
            if (not t.getVar("showRealmNames")) and (toNameFull ~= "...")  then
                toName = Ambiguate(toNameFull, "short")
            end
            i.toText = i.toText or f:CreateFontString(nil, "LOW", nil, 1)
            i.toText:SetFont(t.getVar("fontPath"), 12, "OUTLINE")
            i.toText:SetPoint("BOTTOMLEFT", i.icon, "BOTTOMRIGHT", 5 , 0)
            i.toText:SetVertexColor(1,1,1,1)
            local toColor = t.getClassColor(toNameFull, {colorStr="ffffffff"}).colorStr
            i.toText:SetText("Best for: |c"..toColor..toName.."|r")
            i.toText:Show()

            -- From text
            local fromNameFull = origin
            local fromName = fromNameFull
            if not t.getVar("showRealmNames") then
                fromName = Ambiguate(fromNameFull, "short")
            end
            i.fromText = i.fromText or f:CreateFontString(nil, "LOW", nil, 1)
            i.fromText:SetFont(t.getVar("fontPath"), 12, "OUTLINE")
            i.fromText:SetPoint("BOTTOMLEFT", i.toText, "TOPLEFT", 0 , 3)
            i.fromText:SetVertexColor(1,1,1,1)
            local fromColor = t.getClassColor(fromNameFull, {colorStr="ffffffff"}).colorStr
            i.fromText:SetText("From: |c"..fromColor..fromName.."|r")
            i.fromText:Show()


            -- Create mouseover functions
            local onEnter = function(self, motion)
                GameTooltip:Hide()
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                GameTooltip:SetHyperlink(item.item)
                GameTooltip:Show()
            end

            local onLeave = function(self, motion)
                GameTooltip:Hide()
            end


            -- Bind mouseover functions to icon
            i.iconFrame = i.iconFrame or CreateFrame("Frame")
            i.iconFrame:SetPoint("CENTER", i.icon, "CENTER", 0,0)
            i.iconFrame:SetWidth(i.icon:GetWidth() * GetCVar("uiScale"))
            i.iconFrame:SetHeight(i.icon:GetHeight() * GetCVar("uiScale"))

            i.iconFrame:SetScript("OnEnter", onEnter)
            i.iconFrame:SetScript("OnLeave", onLeave)    

            -- Bind mouseover functions to  item name
            i.nameFrame = i.nameFrame or CreateFrame("Frame")
            i.nameFrame:SetPoint("LEFT", i.nameText, "LEFT", 0,0)
            i.nameFrame:SetWidth((t.ui.MAIN_WINDOW_WIDTH - 18 - t.ui.ITEM_HEIGHT - 4* t.ui.ITEM_INNER_MARGIN) /1.6)
            i.nameFrame:SetHeight(i.nameText:GetHeight())

            i.nameFrame:SetScript("OnEnter", onEnter)
            i.nameFrame:SetScript("OnLeave", onLeave)    


            -- Draw side button

            i.side = i.side or f:CreateTexture(nil, "LOW", nil, 1)
            i.side:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
            i.side:SetPoint("BOTTOMRIGHT", i.bg, "BOTTOMRIGHT", -1, 0)
            i.side:SetWidth(18)
            i.side:SetHeight(t.ui.ITEM_HEIGHT - 18 - 2)
            i.sideColorSet = i.sideColorSet or false
            if not i.sideColorSet then
                i.side:SetVertexColor(.6,.6,.6,0.7)
                i.sideColorSet = true
            end

            i.side:Show()  

            i.sideText = i.sideText or f:CreateFontString(nil, "LOW", nil, 2)
            i.sideText:SetFont(t.getVar("fontPath"), 12, "NONE")
            i.sideText:SetPoint("CENTER", i.side, "CENTER", 0 , 0)
            i.sideText:SetVertexColor(0,0,0,1)
            i.sideText:SetText(">")
            i.sideText:Show()

            -- Create onClick function
            local onClickSide = function(self, button)
                if t.sideWindow and t.sideWindow.activeItem == t.reports[origin][itemID] then
                    t.hideItemScores()
                else
                    t.hideItemScores()
                    -- Set side button color
                    i.side:SetVertexColor(.7,1,1,0.7)
                    t.showItemScores(origin, itemID)


                end
            end

            i.sideFrame = i.sideFrame or CreateFrame("Button", "SideButton")
            i.sideFrame:SetPoint("CENTER", i.side, "CENTER", 0,0)
            i.sideFrame:SetWidth(18 * GetCVar("uiScale"))
            i.sideFrame:SetHeight(i.side:GetHeight() * GetCVar("uiScale"))

            i.sideFrame:SetScript("OnClick", onClickSide)                    

            -- Draw close 'button'
            i.closeBg = i.closeBg or f:CreateTexture(nil, "LOW", nil, 1)
            i.closeBg:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
            i.closeBg:SetPoint("BOTTOM", i.side, "TOP", 0 , 2)
            i.closeBg:SetWidth(18)
            i.closeBg:SetHeight(18)
            i.closeBg:SetVertexColor(.6,.6,.6,0.7)
            i.closeBg:Show()

            i.closeText = i.closeText or f:CreateFontString(nil, "LOW", nil, 2)
            i.closeText:SetFont(t.getVar("fontPath"), 12, "NONE")
            i.closeText:SetPoint("CENTER", i.closeBg, "CENTER", 0, 0)
            i.closeText:SetVertexColor(0,0,0,1)

            i.closeText:SetText("x")
            i.closeText:SetJustifyH("CENTER")
            i.closeText:Show()

            i.closeFrame = i.closeFrame or CreateFrame("Button", "closeButton")
            i.closeFrame:SetPoint("CENTER", i.closeText, "CENTER", 0,0)
            i.closeFrame:SetWidth(18 * GetCVar("uiScale"))
            i.closeFrame:SetHeight(18 * GetCVar("uiScale"))

            -- Create onClick function
            local onClickClose = function(self, button)
                -- Hide sidewindow if open
                if t.sideWindow and t.sideWindow.activeItem == t.reports[origin][itemID] then
                    t.hideItemScores()
                end

                -- Delete the reports
                t.reports[origin][itemID] = nil

                -- Hide last item
                local i = t.itemBars[t.itemCount]
                i.bg:Hide()
                i.icon:Hide()
                i.iconFrame:SetScript("OnEnter", nil)
                i.iconFrame:SetScript("OnLeave", nil)

                i.nameText:Hide()
                i.nameFrame:SetScript("OnEnter", nil)
                i.nameFrame:SetScript("OnLeave", nil)

                i.toText:Hide()
                i.fromText:Hide()
                i.side:Hide()
                i.sideText:Hide()
                i.sideFrame:SetScript("OnClick", nil)
                i.closeText:Hide()
                i.closeBg:Hide()
                i.closeFrame:SetScript("OnClick", nil)

                -- Redraw the bars
                t.drawReports()

            end

            i.closeFrame:SetScript("OnClick", onClickClose)   


        end
    end

    -- Update BG height
    t.bg:SetHeight(t.itemCount * t.ui.ITEM_HEIGHT + (t.itemCount + 1) * t.ui.ITEM_SPACING)



    if t.sideWindow and t.sideWindow.activeItem then
        local a = t.sideWindow.activeItem
        t.showItemScores(a.activeOrigin, a.activeID)

    end


end

t.hideReports = function() 
    local t = TRCLOOT
    if t.bg then
        t.bg:Hide()
        for origin, originVal in pairs(t.reports) do
            for itemID, itemIDVal in pairs(originVal) do
                local i = itemIDVal
                i.bg:Hide()
                i.icon:Hide()
                i.nameText:Hide()
                i.toText:Hide()
                i.fromText:Hide()
                i.side:Hide()
                i.sideText:Hide()
            end
        end
        t.hideItemScores() 
    end

end

t.showItemScores = function(origin, itemID)
    local t = TRCLOOT
    t.reports = t.reports or {}
    local f = t.drawFrame


    -- Contains all data for this item
    local i = t.reports[origin][itemID]

    -- Contains alldata for the side window
    t.sideWindow = t.sideWindow or {}
    local s = t.sideWindow 


    -- Update active item
    s.activeItem = i
    s.activeItem.activeID = itemID
    s.activeItem.activeOrigin = origin



    -- Item BG
    s.bg = s.bg or f:CreateTexture(nil, "LOW", nil, -2)
    s.bg:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
    s.bg:SetVertexColor(.1,.1,.1,0.9)
    s.bg:SetPoint("TOPLEFT", t.bg, "TOPRIGHT", 3, -t.ui.ITEM_SPACING)
    s.bg:SetWidth(t.ui.SIDE_WINDOW_WIDTH)
    i.responses = i.responses or {}
    local playerCount = table.getn(i.responses)
    s.bg:SetHeight(t.ui.PLAYER_HEIGHT * (2+playerCount) + t.ui.PLAYER_SPACING * (playerCount+3) )
    s.bg:Show() 

    -- Get highest score
    local largestUpgrade = 0
    local k = 1
    while i.responses[k] and (i.responses[k].percentUpgrade == t.INFINITE_UPGRADE) do
        k = k +1
    end
    if i.responses[k] and not (i.responses[k].percentUpgrade == t.INFINITE_UPGRADE) then
        if i.responses[k].percentUpgrade > largestUpgrade then
            largestUpgrade = i.responses[k].percentUpgrade
        end
    end

    -- Determine if two equipedSLots 
    local twoIcons = false
    for player, p in pairs(i.responses) do 
        if p.equipedItem2 then
            twoIcons = true
            break
        end
    end


    -- Anchor info
    local anchorTo = s.bg
    local anchorPoint = "TOPRIGHT"
    local anchorOffset = -t.ui.PLAYER_SPACING

    -- Bars are stored in this list
    s.bars = s.bars or {}
    local barIndex = 1

    anchorTo, anchorPoint, anchorOffset, barIndex = t.drawReportBars(true, i, s, f, largestUpgrade, twoIcons, anchorTo, anchorPoint, anchorOffset, barIndex)
    anchorTo, anchorPoint, anchorOffset, barIndex = t.drawReportBars(false, i, s, f, largestUpgrade, twoIcons, anchorTo, anchorPoint, anchorOffset, barIndex)

end

-- For every result (p contains all data for a player)
t.drawReportBars = function(ms, i, s, f, largestUpgrade, twoIcons, anchorTo, anchorPoint, anchorOffset, barIndex) 
   
    local titleBar
    if ms then
        s.titleBarMS = s.titleBarMS or f:CreateTexture(nil, "LOW", nil, -1)
        titleBar = s.titleBarMS
    else
        s.titleBarOS = s.titleBarOS or f:CreateTexture(nil, "LOW", nil, -1)
        titleBar = s.titleBarOS
    end


    titleBar:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
    titleBar:SetVertexColor(.9,.9,.9,.5)
    titleBar:SetPoint("TOPRIGHT", anchorTo, anchorPoint, anchorOffset, -t.ui.PLAYER_INNER_MARGIN)
    local barWidth = t.ui.SIDE_WINDOW_WIDTH- 2*t.ui.PLAYER_SPACING 
    titleBar:SetWidth(barWidth)
    titleBar:SetHeight(t.ui.PLAYER_HEIGHT)
    titleBar:Show() 

    anchorTo = titleBar
    anchorPoint = "BOTTOMRIGHT"


    local titleBarText, titleBarContent
    if ms then
        s.titleBarTextMS = s.titleBarTextMS or f:CreateFontString(nil, "LOW", nil, 1)
        titleBarText = s.titleBarTextMS
        titleBarContent = "Main-Spec"
    else
        s.titleBarTextOS = s.titleBarTextOS or f:CreateFontString(nil, "LOW", nil, 1)
        titleBarText = s.titleBarTextOS
        titleBarContent = "Off-Spec"
    end
    
    anchorOffset = 0


    titleBarText:SetFont(t.getVar("fontPath"), 12, "OUTLINE")
    titleBarText:SetPoint("CENTER", titleBar, "CENTER", 0, 0)
    titleBarText:SetText(titleBarContent)
    titleBarText:Show()



    for player, p in pairs(i.responses) do
        if p.ms == ms then
            -- This contains all info for this bar
            s.bars[barIndex] = s.bars[barIndex] or {}
            local bar = s.bars[barIndex]
            barIndex = barIndex + 1


            -- Currently equiped icon (1)
            local iconName
            if p.equipedItem then
                iconName = GetItemIcon(p.equipedItem)
            else
                iconName = 134400
            end


            bar.icon = bar.icon or f:CreateTexture(nil, "LOW", nil, 0)
            bar.icon:SetTexture(iconName)
            bar.icon:SetTexCoord(.07,.93,.07,.93)
            bar.icon:SetPoint("TOPRIGHT", anchorTo, anchorPoint, 0, -t.ui.PLAYER_SPACING)
            bar.icon:SetWidth(t.ui.PLAYER_HEIGHT)
            bar.icon:SetHeight(t.ui.PLAYER_HEIGHT)
            bar.icon:Show()  

            local last = bar.icon

            -- Create mouseover functions for icon
            local onEnter = function(self, motion)
                if p.equipedItem then
                    GameTooltip:Hide()
                    GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                    GameTooltip:SetHyperlink(p.equipedItem)

                    t.showCompareTooltip(i.item, p.equipedItem, p.primaryStat, p.gemStat, p.gemStatVal, p.statWeights, p.percentUpgrade)


                    GameTooltip:Show()


                end

            end

            local onLeave = function(self, motion)
                GameTooltip.shoppingTooltips[1]:Hide()
                GameTooltip:Hide()
            end


            -- Bind mouseover functions to icon
            bar.iconFrame = bar.iconFrame or CreateFrame("Frame")
            bar.iconFrame:SetPoint("CENTER", bar.icon, "CENTER", 0,0)
            bar.iconFrame:SetWidth(bar.icon:GetWidth() * GetCVar("uiScale"))
            bar.iconFrame:SetHeight(bar.icon:GetHeight() * GetCVar("uiScale"))

            bar.iconFrame:SetScript("OnEnter", onEnter)
            bar.iconFrame:SetScript("OnLeave", onLeave)    

            -- Currently equiped icon (2)
            if twoIcons then
                local iconName2
                if p.equipedItem2 then
                    iconName2 = GetItemIcon(p.equipedItem2)
                else
                    iconName2 = 134400
                end


                bar.icon2 = bar.icon2 or f:CreateTexture(nil, "LOW", nil, 0)
                bar.icon2:SetTexture(iconName2)
                bar.icon2:SetTexCoord(.07,.93,.07,.93)
                bar.icon2:SetPoint("RIGHT", bar.icon, "LEFT", -t.ui.PLAYER_INNER_MARGIN, 0)
                bar.icon2:SetWidth(t.ui.PLAYER_HEIGHT)
                bar.icon2:SetHeight(t.ui.PLAYER_HEIGHT)
                bar.icon2:Show()  

                last = bar.icon2

                -- Create mouseover functions for icon
                local onEnter = function(self, motion)
                    if p.equipedItem2 then
                        GameTooltip:Hide()
                        GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                        GameTooltip:SetHyperlink(p.equipedItem2)
                        t.showCompareTooltip(i.item, p.equipedItem2, p.primaryStat, p.gemStat, p.gemStatVal, p.statWeights, p.percentUpgrade)
                        GameTooltip:Show()
                    end

                end

                local onLeave = function(self, motion)
                    GameTooltip:Hide()
                end


                -- Bind mouseover functions to icon
                bar.iconFrame2 = bar.iconFrame2 or CreateFrame("Frame")
                bar.iconFrame2:SetPoint("CENTER", bar.icon2, "CENTER", 0,0)
                bar.iconFrame2:SetWidth(bar.icon2:GetWidth() * GetCVar("uiScale"))
                bar.iconFrame2:SetHeight(bar.icon2:GetHeight() * GetCVar("uiScale"))

                bar.iconFrame2:SetScript("OnEnter", onEnter)
                bar.iconFrame2:SetScript("OnLeave", onLeave)    

            end


            -- Bar background
            bar.bg = bar.bg or f:CreateTexture(nil, "LOW", nil, -1)
            bar.bg:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
            bar.bg:SetVertexColor(0,0,0,.9)
            bar.bg:SetPoint("RIGHT", last, "LEFT", -t.ui.PLAYER_INNER_MARGIN, 0)
            local barWidth = t.ui.SIDE_WINDOW_WIDTH- 2*t.ui.PLAYER_SPACING - 2* t.ui.PLAYER_INNER_MARGIN - 2*t.ui.PLAYER_HEIGHT
            if twoIcons then
                barWidth = barWidth - t.ui.PLAYER_HEIGHT - t.ui.PLAYER_INNER_MARGIN
            end

            bar.bg:SetWidth(barWidth)
            bar.bg:SetHeight(t.ui.PLAYER_HEIGHT)
            bar.bg:Show() 

            anchorTo = bar.icon
            anchorPoint = "BOTTOMRIGHT"

            -- Player bar
            local barColor = t.getClassColor(p.sender, {r=.6,g=1,b=.6})


            local fraction = 1
            if largestUpgrade > -100 and not (p.percentUpgrade == t.INFINITE_UPGRADE) then
                fraction = (100+p.percentUpgrade) / (100+largestUpgrade)
            end

            bar.bar = bar.bar or f:CreateTexture(nil, "LOW", nil, 0)
            bar.bar:SetTexture("Interface\\AddOns\\WeakAuras\\Media\\Textures\\Square_White")
            bar.bar:SetVertexColor(barColor.r,barColor.g,barColor.b, 0.9)
            bar.bar:SetPoint("LEFT", bar.bg, "LEFT", 0, 0)
            local overlayBarWidth = barWidth * fraction
            -- Always show a little bit of bar
            if overlayBarWidth == 0 then overlayBarWidth = 1 end
            bar.bar:SetWidth(overlayBarWidth)


            bar.bar:SetHeight(t.ui.PLAYER_HEIGHT)
            bar.bar:Show() 




            -- Bar percent text
            bar.percentText = bar.percentText or f:CreateFontString(nil, "LOW", nil, 1)
            bar.percentText:SetFont(t.getVar("fontPath"), 12, "OUTLINE")
            bar.percentText:SetPoint("RIGHT", bar.bg, "RIGHT", -t.ui.PLAYER_INNER_MARGIN , 0)
            local prefix = "+"
            if p.percentUpgrade > 0 then
                bar.percentText:SetVertexColor(.4,1,.4,1)
            elseif p.percentUpgrade < 0 then
                bar.percentText:SetVertexColor(1,.4,.4,1)
                prefix = ""
            else
                bar.percentText:SetVertexColor(1,1,.4,1)
            end

            if p.percentUpgrade == t.INFINITE_UPGRADE then
                bar.percentText:SetText("INFINITE")
            else
                if p.relic then
                    bar.percentText:SetText(string.format("%s%.0f iLvls", prefix, p.percentUpgrade, postfix))
                else
                    bar.percentText:SetText(string.format("%s%.1f%%", prefix, p.percentUpgrade, postfix))
                end
            end

            bar.percentText:Show()


            -- Bar name text
            bar.name = bar.name or f:CreateFontString(nil, "LOW", nil, 1)
            bar.name:SetFont(t.getVar("fontPath"), 12, "OUTLINE")
            bar.name:SetPoint("LEFT", bar.bar, "LEFT", t.ui.PLAYER_INNER_MARGIN , 0)
            bar.name:SetVertexColor(1,1,1,1)
            local nameFull = p.sender
            local name = nameFull
            if not t.getVar("showRealmNames") then
                name = Ambiguate(nameFull, "short")
            end

            bar.name:SetWidth(bar.bg:GetWidth() - bar.percentText:GetWidth())
            bar.name:SetJustifyH("LEFT")
            bar.name:SetWordWrap(false)

            bar.name:SetText(name)
            bar.name:Show()


            -- Spec
            local iconTexture = select(4, GetSpecializationInfoForClassID(p.classID, p.spec))
            bar.specIcon = bar.specIcon or f:CreateTexture(nil, "LOW", nil, 0)
            bar.specIcon:SetTexture(iconTexture)
            bar.specIcon:SetTexCoord(.07,.93,.07,.93)
            bar.specIcon:SetPoint("RIGHT", bar.bg, "LEFT", -t.ui.PLAYER_INNER_MARGIN, 0)
            bar.specIcon:SetWidth(t.ui.PLAYER_HEIGHT)
            bar.specIcon:SetHeight(t.ui.PLAYER_HEIGHT)
            bar.specIcon:Show()  


            -- Spec icon mouseover
            bar.specIconFrame = bar.specIconFrame or CreateFrame("Frame")
            bar.specIconFrame:SetPoint("CENTER", bar.specIcon, "CENTER", 0,0)
            bar.specIconFrame:SetWidth(bar.specIcon:GetWidth() * GetCVar("uiScale"))
            bar.specIconFrame:SetHeight(bar.specIcon:GetHeight() * GetCVar("uiScale"))

            bar.specIconFrame:SetScript("OnEnter", function()
              GameTooltip:SetOwner(bar.specIconFrame)
              GameTooltip:SetPoint("BOTTOMLEFT", bar.specIcon, "TOPRIGHT")
              local specName = select(2, GetSpecializationInfoForClassID(p.classID, p.spec))
              GameTooltip:SetText(specName)
              GameTooltip:Show()
            end)
            bar.specIconFrame:SetScript("OnLeave", function()
                GameTooltip:Hide()
            end)    

        end
    end

    return anchorTo, anchorPoint, anchorOffset, barIndex

end

t.hideItemScores = function()
    local t = TRCLOOT
    local s = t.sideWindow

    if s then
        if t.itemBars then
            for i=1, #(t.itemBars) do
                t.itemBars[i].side:SetVertexColor(.6,.6,.6,.7)
            end
            s.activeItem = nil
        end

        if s.titleBarMS then s.titleBarMS:Hide() end
        if s.titleBarTextMS then s.titleBarTextMS:Hide() end
        if s.titleBarOS then s.titleBarOS:Hide() end
        if s.titleBarTextOS then s.titleBarTextOS:Hide() end

        if s.bars then
            for n=1, #(s.bars) do
                local bar = s.bars[n]
                bar.bg:Hide()
                bar.bar:Hide()
                bar.name:Hide()
                bar.percentText:Hide()
                bar.specIcon:Hide()
                bar.icon:Hide()
                bar.iconFrame:SetScript("OnEnter", nil)
                bar.iconFrame:SetScript("OnLeave", nil)
                if bar.icon2 then
                    bar.icon2:Hide()
                    bar.iconFrame2:SetScript("OnEnter", nil)
                    bar.iconFrame2:SetScript("OnLeave", nil)
                end
            end
        end

        if s.bg then
            s.bg:Hide()
        end
    end

end

t.showCompareTooltip = function(newItem, equipedItem, primaryStat, gemStat, gemStatVal, statWeights, percentUpgrade)

    local sh_tt = GameTooltip.shoppingTooltips[1]
    sh_tt:SetOwner(GameTooltip, "ANCHOR_RIGHT", 0, -GameTooltip:GetHeight())

    sh_tt.needsReset = false
    sh_tt:SetHyperlink(newItem)

    sh_tt:SetMinimumWidth(240)
    sh_tt:AddLine(" ")
    sh_tt:AddLine("If this item is equiped, the following stat changes will occur:", 1,.82,0, true)
    sh_tt:AddLine(" ")

    sh_tt:SetPoint("TOPLEFT", GameTooltip, "TOPRIGHT", 0,0)
    sh_tt:Show()


    local d = {}
    d.newItem = newItem
    d.equipedItem = equipedItem
    d.primaryStat = primaryStat
    d.gemStat = gemStat
    d.gemStatVal = gemStatVal
    d.statWeights = statWeights
    d.percentUpgrade = percentUpgrade
    d.sh_tt = sh_tt

    t.setItemToTooltip(newItem, d, t.showCompareTooltip2)

end


t.showCompareTooltip2 = function(d)

    d.statsNewItem = t.getItemStats(d.newItem, d.primaryStat, d.gemStat, d.gemStatVal)

    t.setItemToTooltip(d.equipedItem, d, t.showCompareTooltip3)

end

t.showCompareTooltip3 = function(d)

    local newItem = d.newItem
    local equipedItem = d.equipedItem
    local primaryStat = d.primaryStat
    local gemStat = d.gemStat
    local gemStatVal = d.gemStatVal
    local statWeights = d.statWeights
    local percentUpgrade = d.percentUpgrade
    local sh_tt = d.sh_tt


    local statsNewItem = d.statsNewItem
    local statsEquipedItem = t.getItemStats(equipedItem, primaryStat, gemStat, gemStatVal)


    local statDiff = t.calculateStatDifferences(statsNewItem, statsEquipedItem, primaryStat, gemStat, gemStatVal)

    local stats = {}

    for stat, val in pairs(statDiff) do
        local swVal = statWeights[t.stm[stat]]
        local swScore = val * (swVal or 0)
        table.insert(stats, {swVal=swVal, stat=stat, val=val, swScore=swScore})
    end

    table.sort(stats ,function(a,b) 
        return a.swVal > b.swVal
    end )

    for n=1, #stats do
        local s = stats[n]


        swValStr = ""
        if s.swVal and s.swScore > 0 then
            swValStr = string.format("x |cffffd200%.1f|r = +|cff00ff00%.1f|r", s.swVal, s.swScore)
        elseif s.swVal and s.swScore < 0 then
            swValStr = string.format("x |cffffd200%.1f|r = |cffff0000%.1f|r", s.swVal, s.swScore)
        elseif s.swVal then
            swValStr = string.format("x |cffffd200%.1f|r = |cffffd2000.0|r", s.swVal, s.swScore)
        end


        if s.val > 0 then
            sh_tt:AddDoubleLine("|cff00ff00+"..s.val.."|r ".._G[s.stat], swValStr, 1,1,1,1,1,1,false)
        elseif s.val < 0 then
            sh_tt:AddDoubleLine("|cffff0000"..s.val.."|r ".._G[s.stat], swValStr, 1,1,1,1,1,1,false)
        end
    end

    --[[
    sh_tt:AddLine(" ")

    local r,g,b
    local sign = ""
    if percentUpgrade > 0 then
        r=0.4
        g=1.0
        b=0.4
    elseif percentUpgrade < 0 then
        r=1.0
        g=0.4
        b=0.4
        sign = ""
    else
        r=1.0
        g=1.0
        b=0.4
    end

    local percentUpgradeStr = string.format("%s%.1f%%", sign, percentUpgrade)
    sh_tt:AddDoubleLine("Percent Upgrade: ", sign..percentUpgradeStr, 1,1,1,r,g,b, false)
    ]]--


    sh_tt:SetPoint("TOPLEFT", GameTooltip, "TOPRIGHT", 0,0)
    sh_tt:Show()
end
